/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "toc_parse.y"

/*
 * toc_parse.y -- parser for toc files
 *
 * Copyright (C) 2004, 2005, 2006, 2007, 2013 Svend Sorensen
 * For license terms, see the file COPYING in this distribution.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "cd.h"
#include "time.h"
#include "toc_parse_prefix.h"

#define YYDEBUG 1

extern int yylex();
void yyerror (char *s);

static Cd *cd = NULL;
static Track *track = NULL;
static Cdtext *cdtext = NULL;

#line 96 "toc_parse.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_TOC_PARSE_H_INCLUDED
# define YY_YY_TOC_PARSE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    NUMBER = 258,                  /* NUMBER  */
    STRING = 259,                  /* STRING  */
    CATALOG = 260,                 /* CATALOG  */
    CD_DA = 261,                   /* CD_DA  */
    CD_ROM = 262,                  /* CD_ROM  */
    CD_ROM_XA = 263,               /* CD_ROM_XA  */
    TRACK = 264,                   /* TRACK  */
    AUDIO = 265,                   /* AUDIO  */
    MODE1 = 266,                   /* MODE1  */
    MODE1_RAW = 267,               /* MODE1_RAW  */
    MODE2 = 268,                   /* MODE2  */
    MODE2_FORM1 = 269,             /* MODE2_FORM1  */
    MODE2_FORM2 = 270,             /* MODE2_FORM2  */
    MODE2_FORM_MIX = 271,          /* MODE2_FORM_MIX  */
    MODE2_RAW = 272,               /* MODE2_RAW  */
    RW = 273,                      /* RW  */
    RW_RAW = 274,                  /* RW_RAW  */
    NO = 275,                      /* NO  */
    COPY = 276,                    /* COPY  */
    PRE_EMPHASIS = 277,            /* PRE_EMPHASIS  */
    TWO_CHANNEL_AUDIO = 278,       /* TWO_CHANNEL_AUDIO  */
    FOUR_CHANNEL_AUDIO = 279,      /* FOUR_CHANNEL_AUDIO  */
    ISRC = 280,                    /* ISRC  */
    SILENCE = 281,                 /* SILENCE  */
    ZERO = 282,                    /* ZERO  */
    AUDIOFILE = 283,               /* AUDIOFILE  */
    DATAFILE = 284,                /* DATAFILE  */
    FIFO = 285,                    /* FIFO  */
    START = 286,                   /* START  */
    PREGAP = 287,                  /* PREGAP  */
    INDEX = 288,                   /* INDEX  */
    CD_TEXT = 289,                 /* CD_TEXT  */
    LANGUAGE_MAP = 290,            /* LANGUAGE_MAP  */
    LANGUAGE = 291,                /* LANGUAGE  */
    TITLE = 292,                   /* TITLE  */
    PERFORMER = 293,               /* PERFORMER  */
    SONGWRITER = 294,              /* SONGWRITER  */
    COMPOSER = 295,                /* COMPOSER  */
    ARRANGER = 296,                /* ARRANGER  */
    MESSAGE = 297,                 /* MESSAGE  */
    DISC_ID = 298,                 /* DISC_ID  */
    GENRE = 299,                   /* GENRE  */
    TOC_INFO1 = 300,               /* TOC_INFO1  */
    TOC_INFO2 = 301,               /* TOC_INFO2  */
    UPC_EAN = 302,                 /* UPC_EAN  */
    SIZE_INFO = 303                /* SIZE_INFO  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define NUMBER 258
#define STRING 259
#define CATALOG 260
#define CD_DA 261
#define CD_ROM 262
#define CD_ROM_XA 263
#define TRACK 264
#define AUDIO 265
#define MODE1 266
#define MODE1_RAW 267
#define MODE2 268
#define MODE2_FORM1 269
#define MODE2_FORM2 270
#define MODE2_FORM_MIX 271
#define MODE2_RAW 272
#define RW 273
#define RW_RAW 274
#define NO 275
#define COPY 276
#define PRE_EMPHASIS 277
#define TWO_CHANNEL_AUDIO 278
#define FOUR_CHANNEL_AUDIO 279
#define ISRC 280
#define SILENCE 281
#define ZERO 282
#define AUDIOFILE 283
#define DATAFILE 284
#define FIFO 285
#define START 286
#define PREGAP 287
#define INDEX 288
#define CD_TEXT 289
#define LANGUAGE_MAP 290
#define LANGUAGE 291
#define TITLE 292
#define PERFORMER 293
#define SONGWRITER 294
#define COMPOSER 295
#define ARRANGER 296
#define MESSAGE 297
#define DISC_ID 298
#define GENRE 299
#define TOC_INFO1 300
#define TOC_INFO2 301
#define UPC_EAN 302
#define SIZE_INFO 303

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 28 "toc_parse.y"

	long ival;
	char *sval;

#line 250 "toc_parse.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_TOC_PARSE_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_NUMBER = 3,                     /* NUMBER  */
  YYSYMBOL_STRING = 4,                     /* STRING  */
  YYSYMBOL_CATALOG = 5,                    /* CATALOG  */
  YYSYMBOL_CD_DA = 6,                      /* CD_DA  */
  YYSYMBOL_CD_ROM = 7,                     /* CD_ROM  */
  YYSYMBOL_CD_ROM_XA = 8,                  /* CD_ROM_XA  */
  YYSYMBOL_TRACK = 9,                      /* TRACK  */
  YYSYMBOL_AUDIO = 10,                     /* AUDIO  */
  YYSYMBOL_MODE1 = 11,                     /* MODE1  */
  YYSYMBOL_MODE1_RAW = 12,                 /* MODE1_RAW  */
  YYSYMBOL_MODE2 = 13,                     /* MODE2  */
  YYSYMBOL_MODE2_FORM1 = 14,               /* MODE2_FORM1  */
  YYSYMBOL_MODE2_FORM2 = 15,               /* MODE2_FORM2  */
  YYSYMBOL_MODE2_FORM_MIX = 16,            /* MODE2_FORM_MIX  */
  YYSYMBOL_MODE2_RAW = 17,                 /* MODE2_RAW  */
  YYSYMBOL_RW = 18,                        /* RW  */
  YYSYMBOL_RW_RAW = 19,                    /* RW_RAW  */
  YYSYMBOL_NO = 20,                        /* NO  */
  YYSYMBOL_COPY = 21,                      /* COPY  */
  YYSYMBOL_PRE_EMPHASIS = 22,              /* PRE_EMPHASIS  */
  YYSYMBOL_TWO_CHANNEL_AUDIO = 23,         /* TWO_CHANNEL_AUDIO  */
  YYSYMBOL_FOUR_CHANNEL_AUDIO = 24,        /* FOUR_CHANNEL_AUDIO  */
  YYSYMBOL_ISRC = 25,                      /* ISRC  */
  YYSYMBOL_SILENCE = 26,                   /* SILENCE  */
  YYSYMBOL_ZERO = 27,                      /* ZERO  */
  YYSYMBOL_AUDIOFILE = 28,                 /* AUDIOFILE  */
  YYSYMBOL_DATAFILE = 29,                  /* DATAFILE  */
  YYSYMBOL_FIFO = 30,                      /* FIFO  */
  YYSYMBOL_START = 31,                     /* START  */
  YYSYMBOL_PREGAP = 32,                    /* PREGAP  */
  YYSYMBOL_INDEX = 33,                     /* INDEX  */
  YYSYMBOL_CD_TEXT = 34,                   /* CD_TEXT  */
  YYSYMBOL_LANGUAGE_MAP = 35,              /* LANGUAGE_MAP  */
  YYSYMBOL_LANGUAGE = 36,                  /* LANGUAGE  */
  YYSYMBOL_TITLE = 37,                     /* TITLE  */
  YYSYMBOL_PERFORMER = 38,                 /* PERFORMER  */
  YYSYMBOL_SONGWRITER = 39,                /* SONGWRITER  */
  YYSYMBOL_COMPOSER = 40,                  /* COMPOSER  */
  YYSYMBOL_ARRANGER = 41,                  /* ARRANGER  */
  YYSYMBOL_MESSAGE = 42,                   /* MESSAGE  */
  YYSYMBOL_DISC_ID = 43,                   /* DISC_ID  */
  YYSYMBOL_GENRE = 44,                     /* GENRE  */
  YYSYMBOL_TOC_INFO1 = 45,                 /* TOC_INFO1  */
  YYSYMBOL_TOC_INFO2 = 46,                 /* TOC_INFO2  */
  YYSYMBOL_UPC_EAN = 47,                   /* UPC_EAN  */
  YYSYMBOL_SIZE_INFO = 48,                 /* SIZE_INFO  */
  YYSYMBOL_49_n_ = 49,                     /* '\n'  */
  YYSYMBOL_50_ = 50,                       /* '{'  */
  YYSYMBOL_51_ = 51,                       /* '}'  */
  YYSYMBOL_52_ = 52,                       /* ':'  */
  YYSYMBOL_53_ = 53,                       /* ','  */
  YYSYMBOL_YYACCEPT = 54,                  /* $accept  */
  YYSYMBOL_tocfile = 55,                   /* tocfile  */
  YYSYMBOL_new_cd = 56,                    /* new_cd  */
  YYSYMBOL_global_statements = 57,         /* global_statements  */
  YYSYMBOL_global_statement = 58,          /* global_statement  */
  YYSYMBOL_disc_mode = 59,                 /* disc_mode  */
  YYSYMBOL_track_list = 60,                /* track_list  */
  YYSYMBOL_track = 61,                     /* track  */
  YYSYMBOL_new_track = 62,                 /* new_track  */
  YYSYMBOL_track_def = 63,                 /* track_def  */
  YYSYMBOL_track_modes = 64,               /* track_modes  */
  YYSYMBOL_track_mode = 65,                /* track_mode  */
  YYSYMBOL_track_sub_mode = 66,            /* track_sub_mode  */
  YYSYMBOL_track_statements = 67,          /* track_statements  */
  YYSYMBOL_track_statement = 68,           /* track_statement  */
  YYSYMBOL_track_flags = 69,               /* track_flags  */
  YYSYMBOL_track_set_flag = 70,            /* track_set_flag  */
  YYSYMBOL_track_clear_flag = 71,          /* track_clear_flag  */
  YYSYMBOL_track_data = 72,                /* track_data  */
  YYSYMBOL_zero_data = 73,                 /* zero_data  */
  YYSYMBOL_track_pregap = 74,              /* track_pregap  */
  YYSYMBOL_track_index = 75,               /* track_index  */
  YYSYMBOL_language_map = 76,              /* language_map  */
  YYSYMBOL_languages = 77,                 /* languages  */
  YYSYMBOL_language = 78,                  /* language  */
  YYSYMBOL_cdtext_langs = 79,              /* cdtext_langs  */
  YYSYMBOL_cdtext_lang = 80,               /* cdtext_lang  */
  YYSYMBOL_cdtext_defs = 81,               /* cdtext_defs  */
  YYSYMBOL_cdtext_def = 82,                /* cdtext_def  */
  YYSYMBOL_cdtext_item = 83,               /* cdtext_item  */
  YYSYMBOL_bytes = 84,                     /* bytes  */
  YYSYMBOL_time = 85,                      /* time  */
  YYSYMBOL_opt_nl = 86                     /* opt_nl  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   149

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  54
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  33
/* YYNRULES -- Number of rules.  */
#define YYNRULES  88
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  156

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   303


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      49,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    53,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    52,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    50,     2,    51,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   103,   103,   107,   114,   115,   119,   120,   121,   122,
     126,   127,   128,   132,   133,   137,   145,   154,   158,   159,
     163,   164,   165,   166,   167,   168,   169,   170,   174,   175,
     179,   180,   184,   185,   186,   187,   188,   189,   190,   194,
     195,   199,   200,   201,   205,   206,   207,   211,   218,   222,
     227,   230,   234,   241,   242,   246,   247,   250,   257,   261,
     265,   266,   270,   274,   275,   279,   283,   284,   288,   291,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   313,   314,   318,   319,   323,   324
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "NUMBER", "STRING",
  "CATALOG", "CD_DA", "CD_ROM", "CD_ROM_XA", "TRACK", "AUDIO", "MODE1",
  "MODE1_RAW", "MODE2", "MODE2_FORM1", "MODE2_FORM2", "MODE2_FORM_MIX",
  "MODE2_RAW", "RW", "RW_RAW", "NO", "COPY", "PRE_EMPHASIS",
  "TWO_CHANNEL_AUDIO", "FOUR_CHANNEL_AUDIO", "ISRC", "SILENCE", "ZERO",
  "AUDIOFILE", "DATAFILE", "FIFO", "START", "PREGAP", "INDEX", "CD_TEXT",
  "LANGUAGE_MAP", "LANGUAGE", "TITLE", "PERFORMER", "SONGWRITER",
  "COMPOSER", "ARRANGER", "MESSAGE", "DISC_ID", "GENRE", "TOC_INFO1",
  "TOC_INFO2", "UPC_EAN", "SIZE_INFO", "'\\n'", "'{'", "'}'", "':'", "','",
  "$accept", "tocfile", "new_cd", "global_statements", "global_statement",
  "disc_mode", "track_list", "track", "new_track", "track_def",
  "track_modes", "track_mode", "track_sub_mode", "track_statements",
  "track_statement", "track_flags", "track_set_flag", "track_clear_flag",
  "track_data", "zero_data", "track_pregap", "track_index", "language_map",
  "languages", "language", "cdtext_langs", "cdtext_lang", "cdtext_defs",
  "cdtext_def", "cdtext_item", "bytes", "time", "opt_nl", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-87)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-17)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -87,     5,   -87,   -87,    12,   -38,    11,   -87,   -87,   -87,
     -27,   -87,   -19,    29,   -87,    30,   -87,    -9,    -8,   -87,
     -87,    79,    53,   -87,   -87,     8,   -87,   -87,   -87,   -87,
     -87,   -87,   -87,   -87,    -5,     9,     6,    10,    22,    23,
      48,    49,    95,   -87,   -87,   108,   109,   111,    -2,   113,
     113,    67,    36,   -87,   -87,   -87,   -87,   -87,   113,   -87,
     -87,    68,    83,   -87,   -87,   -87,   -87,   -87,    71,    72,
     -87,   -87,   -87,   -87,    73,   113,     0,   113,    74,   -87,
      75,    76,    78,    -8,   -87,    80,    -8,   120,   -26,   -87,
     -87,   -87,   -87,     1,   -87,    81,    82,   125,   -87,   -87,
     -87,    83,   -87,   129,    84,    86,   -87,   -87,    87,   -87,
     -87,    85,   -22,    88,    -3,   -87,    -8,   -87,   -87,   130,
      89,   136,    92,   -87,   -87,   -87,   -87,    -8,   -87,    63,
     -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,
     -87,   -87,   -87,   -87,    93,   -87,     2,   -87,    94,   -87,
     -87,   -29,    96,   141,   -87,   -87
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       3,     0,     4,     1,     0,     0,     0,    10,    11,    12,
       0,     5,     0,     2,    13,     0,     9,     0,    87,     7,
      14,     0,     0,     6,    88,     0,    20,    21,    22,    23,
      24,    25,    26,    27,     0,    18,     0,     0,     0,     0,
       0,     0,     0,    53,    54,     0,     0,     0,     0,     0,
       0,     0,     0,    30,    32,    39,    40,    35,     0,    36,
      37,     0,     0,    17,    28,    29,    19,    38,     0,     0,
      41,    42,    46,    43,     0,     0,     0,     0,    85,    55,
       0,     0,     0,    87,    31,     0,    87,     0,     0,    63,
      45,    44,    33,     0,    50,     0,     0,     0,    56,    57,
      58,     0,    47,     0,     0,     0,    64,    48,     0,    51,
      52,     0,     0,     0,     0,    60,    87,     8,    49,     0,
       0,     0,     0,    61,    66,    86,    34,    87,    59,     0,
      62,    81,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    82,     0,    67,     0,    65,     0,    83,
      68,     0,     0,     0,    69,    84
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -87,   -87,   -87,   -87,   -87,   -87,   -87,   133,   -87,   -87,
     -87,   -87,   -87,   -87,    97,   -87,   -87,   -87,   -87,   -87,
     -87,   -87,   -87,   -87,    33,    47,   -86,   -87,   -87,   -87,
     -87,   -42,   -74
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,     2,     4,    11,    12,    13,    14,    15,    22,
      34,    35,    66,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    62,   114,   115,    88,    89,   129,   145,   146,
     151,    80,    25
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     113,    78,   106,    78,    78,     3,   148,    81,    82,   101,
      87,    16,   103,     5,    87,    17,    85,     6,     7,     8,
       9,   -16,   152,    18,   153,   105,   106,    64,    65,   120,
      19,    68,    69,    93,    95,    96,   -15,    36,   -16,    21,
      23,    24,   124,    61,    63,   -15,    10,    79,   122,    94,
     107,   108,   149,   130,    36,    67,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    70,    71,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,   131,    26,
      27,    28,    29,    30,    31,    32,    33,    72,    73,    74,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,    75,    76,   144,    77,    78,    83,    86,    87,
      90,    91,    92,   104,    98,    99,    97,   100,   111,   102,
     109,   110,   113,   125,   116,   117,   118,   119,   126,   127,
     121,   128,   147,   150,   155,   154,    20,   123,   112,    84
};

static const yytype_int8 yycheck[] =
{
       3,     3,    88,     3,     3,     0,     4,    49,    50,    83,
      36,    49,    86,     1,    36,     4,    58,     5,     6,     7,
       8,     9,    51,    50,    53,    51,   112,    18,    19,    51,
      49,    21,    22,    75,    76,    77,     0,     1,     9,     9,
      49,    49,   116,    35,    49,     9,    34,    49,    51,    49,
      49,    93,    50,   127,     1,    49,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    49,    49,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    25,    10,
      11,    12,    13,    14,    15,    16,    17,    49,    49,     4,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,     4,     4,    51,     4,     3,    50,    50,    36,
      49,    49,    49,     3,    49,    49,    52,    49,     3,    49,
      49,    49,     3,     3,    50,    49,    49,    52,    49,     3,
      52,    49,    49,    49,     3,    49,    13,   114,   101,    52
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    55,    56,     0,    57,     1,     5,     6,     7,     8,
      34,    58,    59,    60,    61,    62,    49,     4,    50,    49,
      61,     9,    63,    49,    49,    86,    10,    11,    12,    13,
      14,    15,    16,    17,    64,    65,     1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    35,    76,    49,    18,    19,    66,    49,    21,    22,
      49,    49,    49,    49,     4,     4,     4,     4,     3,    49,
      85,    85,    85,    50,    68,    85,    50,    36,    79,    80,
      49,    49,    49,    85,    49,    85,    85,    52,    49,    49,
      49,    86,    49,    86,     3,    51,    80,    49,    85,    49,
      49,     3,    79,     3,    77,    78,    50,    49,    49,    52,
      51,    52,    51,    78,    86,     3,    49,     3,    49,    81,
      86,    25,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    51,    82,    83,    49,     4,    50,
      49,    84,    51,    53,    49,     3
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    54,    55,    56,    57,    57,    58,    58,    58,    58,
      59,    59,    59,    60,    60,    61,    62,    63,    64,    64,
      65,    65,    65,    65,    65,    65,    65,    65,    66,    66,
      67,    67,    68,    68,    68,    68,    68,    68,    68,    69,
      69,    70,    70,    70,    71,    71,    71,    72,    72,    72,
      72,    72,    72,    73,    73,    74,    74,    74,    75,    76,
      77,    77,    78,    79,    79,    80,    81,    81,    82,    82,
      83,    83,    83,    83,    83,    83,    83,    83,    83,    83,
      83,    83,    83,    84,    84,    85,    85,    86,    86
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     3,     0,     0,     2,     3,     2,     7,     2,
       1,     1,     1,     1,     2,     3,     0,     3,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     3,     6,     1,     1,     1,     2,     1,
       1,     2,     2,     2,     3,     3,     2,     3,     4,     5,
       3,     4,     4,     1,     1,     2,     3,     3,     3,     6,
       1,     2,     4,     1,     2,     7,     0,     2,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     3,     1,     5,     0,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* new_cd: %empty  */
#line 107 "toc_parse.y"
                      {
		cd = cd_init();
		cdtext = cd_get_cdtext(cd);
	}
#line 1426 "toc_parse.c"
    break;

  case 6: /* global_statement: CATALOG STRING '\n'  */
#line 119 "toc_parse.y"
                              { cd_set_catalog(cd, (yyvsp[-1].sval)); }
#line 1432 "toc_parse.c"
    break;

  case 7: /* global_statement: disc_mode '\n'  */
#line 120 "toc_parse.y"
                         { cd_set_mode(cd, (yyvsp[-1].ival)); }
#line 1438 "toc_parse.c"
    break;

  case 15: /* track: new_track track_def track_statements  */
#line 137 "toc_parse.y"
                                               {
		while (2 > track_get_nindex(track)) {
			track_add_index(track, 0);
		}
	}
#line 1448 "toc_parse.c"
    break;

  case 16: /* new_track: %empty  */
#line 145 "toc_parse.y"
                      {
		track = cd_add_track(cd);
		cdtext = track_get_cdtext(track);
		/* add 0 index */
		track_add_index(track, 0);
	}
#line 1459 "toc_parse.c"
    break;

  case 17: /* track_def: TRACK track_modes '\n'  */
#line 154 "toc_parse.y"
                                 { track_set_mode(track, (yyvsp[-1].ival)); }
#line 1465 "toc_parse.c"
    break;

  case 19: /* track_modes: track_mode track_sub_mode  */
#line 159 "toc_parse.y"
                                    { track_set_sub_mode(track, (yyvsp[0].ival)); }
#line 1471 "toc_parse.c"
    break;

  case 33: /* track_statement: ISRC STRING '\n'  */
#line 185 "toc_parse.y"
                           { track_set_isrc(track, (yyvsp[-1].sval)); }
#line 1477 "toc_parse.c"
    break;

  case 39: /* track_flags: track_set_flag  */
#line 194 "toc_parse.y"
                         { track_set_flag(track, (yyvsp[0].ival)); }
#line 1483 "toc_parse.c"
    break;

  case 40: /* track_flags: track_clear_flag  */
#line 195 "toc_parse.y"
                           { track_clear_flag(track, (yyvsp[0].ival)); }
#line 1489 "toc_parse.c"
    break;

  case 44: /* track_clear_flag: NO PRE_EMPHASIS '\n'  */
#line 205 "toc_parse.y"
                               { (yyval.ival) = (yyvsp[-1].ival); }
#line 1495 "toc_parse.c"
    break;

  case 45: /* track_clear_flag: NO COPY '\n'  */
#line 206 "toc_parse.y"
                       { (yyval.ival) = (yyvsp[-1].ival); }
#line 1501 "toc_parse.c"
    break;

  case 47: /* track_data: zero_data time '\n'  */
#line 211 "toc_parse.y"
                              {
		if (NULL == track_get_filename(track)) {
			track_set_zero_pre(track, (yyvsp[-1].ival));
		} else {
			track_set_zero_post(track, (yyvsp[-1].ival));
		}
	}
#line 1513 "toc_parse.c"
    break;

  case 48: /* track_data: AUDIOFILE STRING time '\n'  */
#line 218 "toc_parse.y"
                                     {
		track_set_filename(track, (yyvsp[-2].sval));
		track_set_start(track, (yyvsp[-1].ival));
	}
#line 1522 "toc_parse.c"
    break;

  case 49: /* track_data: AUDIOFILE STRING time time '\n'  */
#line 222 "toc_parse.y"
                                          {
		track_set_filename(track, (yyvsp[-3].sval));
		track_set_start(track, (yyvsp[-2].ival));
		track_set_length(track, (yyvsp[-1].ival));
	}
#line 1532 "toc_parse.c"
    break;

  case 50: /* track_data: DATAFILE STRING '\n'  */
#line 227 "toc_parse.y"
                               {
		track_set_filename(track, (yyvsp[-1].sval));
	}
#line 1540 "toc_parse.c"
    break;

  case 51: /* track_data: DATAFILE STRING time '\n'  */
#line 230 "toc_parse.y"
                                    {
		track_set_filename(track, (yyvsp[-2].sval));
		track_set_start(track, (yyvsp[-1].ival));
	}
#line 1549 "toc_parse.c"
    break;

  case 52: /* track_data: FIFO STRING time '\n'  */
#line 234 "toc_parse.y"
                                {
		track_set_filename(track, (yyvsp[-2].sval));
		track_set_start(track, (yyvsp[-1].ival));
	}
#line 1558 "toc_parse.c"
    break;

  case 56: /* track_pregap: START time '\n'  */
#line 247 "toc_parse.y"
                          {
		track_add_index(track, (yyvsp[-1].ival));
	}
#line 1566 "toc_parse.c"
    break;

  case 57: /* track_pregap: PREGAP time '\n'  */
#line 250 "toc_parse.y"
                           {
		track_set_zero_pre(track, (yyvsp[-1].ival));
		track_add_index(track, (yyvsp[-1].ival));
	}
#line 1575 "toc_parse.c"
    break;

  case 58: /* track_index: INDEX time '\n'  */
#line 257 "toc_parse.y"
                          { track_add_index(track, (yyvsp[-1].ival)); }
#line 1581 "toc_parse.c"
    break;

  case 62: /* language: NUMBER ':' NUMBER opt_nl  */
#line 270 "toc_parse.y"
                                   { /* not implemented */ }
#line 1587 "toc_parse.c"
    break;

  case 68: /* cdtext_def: cdtext_item STRING '\n'  */
#line 288 "toc_parse.y"
                                  {
		cdtext_set ((yyvsp[-2].ival), (yyvsp[-1].sval), cdtext);
	}
#line 1595 "toc_parse.c"
    break;

  case 69: /* cdtext_def: cdtext_item '{' bytes '}' '\n'  */
#line 291 "toc_parse.y"
                                         {
		yyerror("binary CD-TEXT data not supported\n");
	}
#line 1603 "toc_parse.c"
    break;

  case 86: /* time: NUMBER ':' NUMBER ':' NUMBER  */
#line 319 "toc_parse.y"
                                       { (yyval.ival) = time_msf_to_frame((yyvsp[-4].ival), (yyvsp[-2].ival), (yyvsp[0].ival)); }
#line 1609 "toc_parse.c"
    break;


#line 1613 "toc_parse.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 327 "toc_parse.y"


/* lexer interface */
extern int toc_lineno;
extern int yydebug;
extern FILE *toc_yyin;

void yyerror (char *s)
{
	fprintf(stderr, "%d: %s\n", toc_lineno, s);
}

Cd *toc_parse (FILE *fp)
{
	toc_yyin = fp;
	yydebug = 0;

	if (0 == yyparse()) {
		return cd;
	}

	return NULL;
}
